unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    btnSave: TButton;
    edtInput: TEdit;
    Label1: TLabel;
    procedure btnSaveClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses RVEdit, RVStyle;
                       
var
  gFontName: TStringList;

function EnumFontsProc (var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
begin
  TStrings (Data).Add (LogFont.lfFaceName);
  Result := 1;
end;

{$R *.dfm}

function GetFontNames: TStringList;
var
  DC: HDC;
begin
  if gFontName = nil then
  begin
    gFontName := TStringList.Create;
    DC := GetDC (0);
    EnumFonts (DC, nil, @EnumFontsProc, Pointer (gFontName));
    ReleaseDC (0, DC);
    gFontName.Sorted := True;
  end;
  Result := gFontName;
end;

function GetDefaultFontName (): string;
begin
  result := 'Arial';
end;

procedure TForm1.btnSaveClick(Sender: TObject);
var
  RichViewEdit: TRichViewEdit;
  RVStyle: TRVStyle;             
  bRet: boolean;
  HTMLSaveOptions: TRVSaveOptions;   
  FontInfos: TFontInfos;
  FontInfo: TFontInfo;
  i: integer;
begin
  RichViewEdit := nil;
  RVStyle := nil;

  try
    HTMLSaveOptions := [rvsoImageSizes, rvsoUseCheckpointsNames, rvsoUTF8];

    RVStyle := TRVStyle.Create (nil);
    RVStyle.DefUnicodeStyle := -1;

    RichViewEdit := TRichViewEdit.Create (nil);
    RichViewEdit.Style := RVStyle;

    RichViewEdit.RTFReadProperties.UnicodeMode := rvruMixed;

    RichViewEdit.DeleteUnusedStyles (true, true, true);
    RichViewEdit.RTFReadProperties.ParaStyleMode := rvrsAddIfNeeded;
    RichViewEdit.RTFReadProperties.TextStyleMode := rvrsAddIfNeeded;

    try
      bRet := RichViewEdit.LoadRTF (edtInput.Text);
    except
      on E: Exception do
      begin
        bRet := false;
      end;
    end;

    try
      // mkoe, v3005: Bug bei LV1871:
      // Fehlende Schriftart lsst Wrter im Browser verschwinden
      FontInfos := RichViewEdit.Style.TextStyles;
      for i := 0 to FontInfos.Count - 1 do
      begin
        FontInfo := FontInfos.Items[i];
        if GetFontNames ().IndexOf (FontInfo.FontName) < 0 then
          FontInfo.FontName := GetDefaultFontName ();
      end;
    except
      on E: Exception do
      begin
        bRet := false;
      end;
    end;

    try
      if bRet then
      begin
        bRet := RichViewEdit.SaveHTML (edtInput.Text + '.htm',
          'RTF to HTML',
          'img',
          HTMLSaveOptions);
      end;
    except
      on E: Exception do
      begin
        bRet := false;
      end;
    end;

  finally
    RichViewEdit.Free;
    RVStyle.Free;
  end;
end;

end.
